# OPTIONAL_PROGRAM(optname, progpath[optname])
AC_DEFUN([OPTIONAL_PROGRAM],
[AC_ARG_ENABLE([$1],AC_HELP_STRING([--enable-xtalmon],[Build optional [$2] program. Default: Off]),
     [case "${enableval}" in
       yes) OPTPROGRAMS="$OPTPROGRAMS m4_default([$2],[$1])" 
            AC_MSG_NOTICE([Optional program [$1] included]);; 
       no)  AC_MSG_NOTICE([Optional program [$1] omitted]);; 
       *) AC_MSG_ERROR(bad value ${enableval} for --enable-[$1]) ;;
     esac],
     [AC_MSG_NOTICE([Optional program [$1] not built by default])
  ])
  AC_SUBST(OPTPROGRAMS)])

# USER_DIRS
#  Add ~/lib and ~/include to lib/include paths if they exist
AC_DEFUN([USER_DIRS],
[if test -e $HOME/lib ; then
   LDFLAGS="$LDFLAGS -L$HOME/lib"
   AC_MSG_NOTICE([Using user lib directory $HOME/lib])
fi;
 if test -e $HOME/include ; then
   CFLAGS="$CFLAGS -I$HOME/include"
   CPPFLAGS="$CPPFLAGS -I$HOME/include"
   AC_MSG_NOTICE([Using user include directory $HOME/include])
 fi;
])

# DISABLE_PROGRAM(optname, progpath[optname])
#AC_DEFUN([DISABLE_PROGRAM],
#[AC_ARG_ENABLE([$1],AC_HELP_STRING([--enable-xtalmon],[Build optional [$2] program. Default: On]),
#     [case "${enableval}" in
#       yes) OPTPROGRAMS="$OPTPROGRAMS m4_default([$2],[$1])" 
#            AC_MSG_NOTICE([Optional program [$1] included]);; 
#       no)  AC_MSG_NOTICE([Optional program [$1] omitted]);; 
#       *) AC_MSG_ERROR(bad value ${enableval} for --enable-[$1]) ;;
#     esac],[AC_MSG_NOTICE([Optional program [$1] built by default]) OPTPROGRAMS="$OPTPROGRAMS m4_default([$2],[$1])" ])
#  AC_SUBST(OPTPROGRAMS)])
